> Documentation index for AI agents: https://docs.pagerduty.com/llms.txt

# List Incident Type Custom Fields

`GET https://api.pagerduty.com/incidents/types/{type_id_or_name}/custom_fields`

List the custom fields for an incident type.

Custom Fields (CF) are a feature which will allow customers to extend Incidents with their own custom data,
to provide additional context and support features such as customized filtering, search and analytics.
Custom Fields can be applied to different incident types.

Scoped OAuth requires: `custom_fields.read`

## Authorization

- **api_key** (apiKey) — `Authorization` header. The API Key with format `Token token=<API_KEY>`

## Path parameters

| Name | Type | Required | Description |
|---|---|---|---|
| `type_id_or_name` | string | yes | The ID or name of the Incident Type. |

## Query parameters

| Name | Type | Required | Description |
|---|---|---|---|
| `include[]` | string |  | Array of additional details to include. One of: `field_options`. Items must be unique. |

## Header parameters

| Name | Type | Required | Description |
|---|---|---|---|
| `Accept` | string | yes | The `Accept` header is used as a versioning header. Default: `application/vnd.pagerduty+json;version=2`. |

## Response 200

The custom fields for the incident type requested. Passing in include[]=field_options will return the field options for the custom field.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `fields` | array of object | yes |  |
| `fields[].enabled` | boolean | yes | Whether the custom field is enabled. Read-only. |
| `fields[].id` | string | yes | The ID of the resource. Read-only. |
| `fields[].name` | string | yes | The name of the field. May include ASCII characters, specifically lowercase letters, digits, and underescores. The `name` for a Field must be unique and cannot be changed once created. Max length: 50. |
| `fields[].type` | string | yes | Read-only. One of: `field`. |
| `fields[].self` | string \| null (url) | yes | The API show URL at which the object is accessible. Read-only. |
| `fields[].description` | string \| null |  | A description of the data this field contains. Max length: 1000. |
| `fields[].field_type` | string | yes | The type of data this field contains. In combination with the `data_type` field. One of: `single_value`, `single_value_fixed`, `multi_value`, `multi_value_fixed`. |
| `fields[].data_type` | string | yes | The kind of data the custom field is allowed to contain. One of: `boolean`, `integer`, `float`, `string`, `datetime`, `url`. |
| `fields[].updated_at` | string (date-time) | yes | The date/time the object was last updated. Read-only. |
| `fields[].created_at` | string (date-time) | yes | The date/time the object was created at. Read-only. |
| `fields[].display_name` | string | yes | The human-readable name of the field. This must be unique across an account. Max length: 50. |
| `fields[].default_value` | one of: object \| object \| object \| object \| object \| object |  |  |
| `fields[].default_value.value` | boolean \| null |  | (Boolean) |
| `fields[].default_value.value` | integer \| null |  | (Integer) |
| `fields[].default_value.value` | number \| null |  | (Float) |
| `fields[].default_value.value` | one of: string \| null \| array \| null |  | (String) |
| `fields[].default_value.value` | string \| null (date-time) |  | (Datetime) |
| `fields[].default_value.value` | string \| null (uri) |  | (Url) Max length: 200. |
| `fields[].incident_type` | string | yes | The id of the incident type the custom field is associated with. Read-only. |
| `fields[].summary` | string \| null | yes | A short-form, server-generated string that provides succinct, important information about an object suitable for primary labeling of an entity in a client. In many cases, this will be identical to `name`, though it is not intended to be an identifier. Read-only. |
| `fields[].field_options` | array of object |  | The options for the custom field. Applies only to `single_value_fixed` and `multi_value_fixed` field types. Optionally included in response based on query parameter. |
| `fields[].field_options[].id` | string |  |  |
| `fields[].field_options[].type` | string |  | One of: `field_option`. |
| `fields[].field_options[].updated_at` | string (date-time) |  | The date/time the field option was last updated. Read-only. |
| `fields[].field_options[].created_at` | string (date-time) |  | The date/time the field option was created at. Read-only. |
| `fields[].field_options[].data` | object |  |  |
| `fields[].field_options[].data.value` | string |  |  |
| `fields[].field_options[].data.data_type` |  |  | One of: `string`. |

Example: Response Example - No query parameters

```json
{
  "fields": [
    {
      "enabled": true,
      "id": "P567890",
      "name": "incident_commander",
      "type": "field",
      "self": "https://api.pagerduty.com/incidents/types/P123456/custom_fields/P567890",
      "description": "field description",
      "field_type": "single_value_fixed",
      "data_type": "string",
      "created_at": "2023-05-31T13:41:47Z",
      "updated_at": "2023-07-31T13:41:47Z",
      "display_name": "Incident Commander",
      "default_value": "John Doe",
      "incident_type": "Security Incident",
      "summary": "incident_commander"
    },
    {
      "enabled": true,
      "id": "P456789",
      "name": "due_date",
      "type": "field",
      "self": "https://api.pagerduty.com/incidents/types/P123456/custom_fields/P456789",
      "description": "field description",
      "field_type": "single_value",
      "data_type": "string",
      "created_at": "2024-05-31T13:41:47Z",
      "updated_at": "2024-07-31T13:41:47Z",
      "display_name": "Due Date",
      "default_value": "2025-07-31T13:41:47Z",
      "incident_type": "Security Incident 2",
      "summary": "due_date"
    }
  ]
}
```

Example: Response Example - Include field options

```json
{
  "fields": [
    {
      "enabled": true,
      "id": "P567890",
      "name": "incident_commander",
      "type": "field",
      "self": "https://api.pagerduty.com/incidents/types/P123456/custom_fields/P567890",
      "description": "field description",
      "field_type": "single_value_fixed",
      "data_type": "string",
      "created_at": "2023-05-31T13:41:47Z",
      "updated_at": "2023-07-31T13:41:47Z",
      "display_name": "Incident Commander",
      "default_value": "John Doe",
      "incident_type": "Security Incident",
      "summary": "incident_commander",
      "field_options": [
        {
          "id": "PT4KHEE",
          "type": "field_option",
          "data": {
            "data_type": "string",
            "value": "John Doe"
          },
          "created_at": "2021-06-01T21:30:42Z",
          "updated_at": "2021-06-01T21:30:42Z"
        },
        {
          "id": "P5IYCNZ",
          "type": "field_option",
          "data": {
            "data_type": "string",
            "value": "Jane Smith"
          },
          "created_at": "2021-06-01T21:30:42Z",
          "updated_at": "2021-06-01T21:30:42Z"
        }
      ]
    },
    {
      "enabled": true,
      "id": "P456789",
      "name": "due_date",
      "type": "field",
      "self": "https://api.pagerduty.com/incidents/types/P123456/custom_fields/P456789",
      "description": "field description",
      "field_type": "single_value",
      "data_type": "string",
      "created_at": "2024-05-31T13:41:47Z",
      "updated_at": "2024-07-31T13:41:47Z",
      "display_name": "Due Date",
      "default_value": "2025-07-31T13:41:47Z",
      "incident_type": "Security Incident 2",
      "summary": "due_date"
    }
  ]
}
```

## Response 400

Caller provided invalid arguments. Please review the response for error details. Retrying with the same arguments will *not* work.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Response 401

Caller did not supply credentials or did not provide the correct credentials.
If you are using an API key, it may be invalid or your Authorization header may be malformed.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Response 402

Account does not have the abilities to perform the action. Please review the response for the required abilities.
You can also use the [Abilities API](#resource_Abilities) to determine what features are available to your account.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Response 403

Caller is not authorized to view the requested resource.
While your authentication is valid, the authenticated user or token does not have permission to perform this action.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Response 404

The requested resource was not found.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Response 500

Internal Server Error the PagerDuty server experienced an error.

### `application/json`

| Field | Type | Required | Description |
|---|---|---|---|
| `error` | object |  |  |
| `error.code` | integer |  | Read-only. |
| `error.message` | string |  | Error message string. Read-only. |
| `error.errors` | array of string |  | Read-only. |

## Developer Agreement

Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement).
